;
;	BUILD  --  a blocks world
;
;	Originally by Scott Fahlman, as part of a Master's thesis
;	at MIT in 1973.	Described in AI	Journal, Vol 5,	pp 1ff,
;	in 1974.
;
;	Brought back to life in 1987 by John Nagle.
;	Keyboarded from Fahlman's Conniver source, converted to Common
;	Lisp, and extended.
;
;						Version 1.7 of 5/14/87
;
;
;	"Main Program"
;
;	Just loads everything.
;
;	First load packages.
;
(require 'database "database")
(use-package 'database)
(require 'builddefs "builddefs")
(use-package 'builddefs)
(require 'vector "vector")
(use-package 'vector)
(require 'buildutil "buildutil")
(use-package 'buildutil)
(require 'collision "build5")
(use-package 'collision)
(require 'stability "build6")
(use-package 'stability)

(require 'build3 "build3")
(require 'build4 "build4")
(require 'build7 "build7")
(require 'build8 "build8")
(require 'buildshapes "buildshapes")
(require 'plandefs "plandefs")
(require 'plan1 "plan1")
(require 'plan2 "plan2")
(require 'plan3 "plan3")
(require 'plan4 "plan4")
(require 'plan5 "plan5")
(require 'planutil "planutil")
(require 'uplot "uplot")
(require 'dummies "dummies")
(require 'drawtools "drawtools")
(require 'printplan "printplan")
(require 'robotio "robotio")
(require 'amlparse "amlparse")
